std::experimental::fundamentals_v1::optional< _Tp > Class Template Reference
Experimental » Optional values

`#include <optional>`

Inheritance diagram for std::experimental::fundamentals_v1::optional< _Tp >:
[legend]

## Public Types

using | value_type = _Tp

## Public Member Functions

template<typename _Up = _Tp, enable_if_t< __and_< __not_< is_same< optional< _Tp >, decay_t< _Up > > >, is_constructible< _Tp, _Up && >, is_convertible< _Up &&, _Tp > >::value, bool > = true>
constexpr | optional (_Up &&__t)
template<typename _Up = _Tp, enable_if_t< __and_< __not_< is_same< optional< _Tp >, decay_t< _Up > > >, is_constructible< _Tp, _Up && >, __not_< is_convertible< _Up &&, _Tp > > >::value, bool > = false>
constexpr | optional (_Up &&__t)
template<typename _Up , enable_if_t< __and_< __not_< is_same< _Tp, _Up > >, is_constructible< _Tp, const _Up & >, is_convertible< const _Up &, _Tp >, __not_< __converts_from_optional< _Tp, _Up > > >::value, bool > = true>
constexpr | optional (const optional< _Up > &__t)
template<typename _Up , enable_if_t< __and_< __not_< is_same< _Tp, _Up > >, is_constructible< _Tp, const _Up & >, __not_< is_convertible< const _Up &, _Tp > >, __not_< __converts_from_optional< _Tp, _Up > > >::value, bool > = false>
constexpr | optional (const optional< _Up > &__t)
template<typename _Up , enable_if_t< __and_< __not_< is_same< _Tp, _Up > >, is_constructible< _Tp, _Up && >, is_convertible< _Up &&, _Tp >, __not_< __converts_from_optional< _Tp, _Up > > >::value, bool > = true>
constexpr | optional (optional< _Up > &&__t)
template<typename _Up , enable_if_t< __and_< __not_< is_same< _Tp, _Up > >, is_constructible< _Tp, _Up && >, __not_< is_convertible< _Up &&, _Tp > >, __not_< __converts_from_optional< _Tp, _Up > > >::value, bool > = false>
constexpr | optional (optional< _Up > &&__t)
template<typename... _Args>
enable_if_t< is_constructible< _Tp, _Args &&... >::value > | emplace (_Args &&... __args)
template<typename _Up , typename... _Args>
enable_if_t< is_constructible< _Tp, initializer_list< _Up > &, _Args &&... >::value > | emplace (initializer_list< _Up > __il, _Args &&... __args)
constexpr | operator bool () const noexcept
constexpr _Tp & | operator* () &
constexpr _Tp && | operator* () &&
constexpr const _Tp & | operator* () const &
constexpr const _Tp && | operator* () const &&
_Tp * | operator-> ()
constexpr const _Tp * | operator-> () const
template<typename _Up = _Tp>
enable_if_t< __and_< __not_< is_same< optional< _Tp >, decay_t< _Up > > >, is_constructible< _Tp, _Up >, __not_< __and_< is_scalar< _Tp >, is_same< _Tp, decay_t< _Up > > > >, is_assignable< _Tp &, _Up > >::value, optional & > | operator= (_Up &&__u)
template<typename _Up >
enable_if_t< __and_< __not_< is_same< _Tp, _Up > >, is_constructible< _Tp, const _Up & >, is_assignable< _Tp &, _Up >, __not_< __converts_from_optional< _Tp, _Up > >, __not_< __assigns_from_optional< _Tp, _Up > > >::value, optional & > | operator= (const optional< _Up > &__u)
optional & | operator= (nullopt_t) noexcept
template<typename _Up >
enable_if_t< __and_< __not_< is_same< _Tp, _Up > >, is_constructible< _Tp, _Up >, is_assignable< _Tp &, _Up >, __not_< __converts_from_optional< _Tp, _Up > >, __not_< __assigns_from_optional< _Tp, _Up > > >::value, optional & > | operator= (optional< _Up > &&__u)
void | swap (optional &__other) noexcept(is_nothrow_move_constructible< _Tp >() &&__is_nothrow_swappable< _Tp >::value)
constexpr _Tp & | value () &
constexpr _Tp && | value () &&
constexpr const _Tp & | value () const &
constexpr const _Tp && | value () const &&
template<typename _Up >
_Tp | value_or (_Up &&__u) &&
template<typename _Up >
constexpr _Tp | value_or (_Up &&__u) const &

## Detailed Description

template<typename _Tp>
class std::experimental::fundamentals_v1::optional< _Tp >

Class template for optional values.

Definition at line 491 of file optional.

## Member Typedef Documentation

## value_type

template<typename _Tp >

using std::experimental::fundamentals_v1::optional< _Tp >::value_type = _Tp

Definition at line 514 of file optional.

## Constructor & Destructor Documentation

## optional() [1/6]

template<typename _Tp >
template<typename _Up = _Tp, enable_if_t< __and_< __not_< is_same< optional< _Tp >, decay_t< _Up > > >, is_constructible< _Tp, _Up && >, is_convertible< _Up &&, _Tp > >::value, bool > = true>

constexpr std::experimental::fundamentals_v1::optional< _Tp >::optional | ( | _Up && | __t | ) |

inline constexpr

Definition at line 527 of file optional.

## optional() [2/6]

template<typename _Tp >
template<typename _Up = _Tp, enable_if_t< __and_< __not_< is_same< optional< _Tp >, decay_t< _Up > > >, is_constructible< _Tp, _Up && >, __not_< is_convertible< _Up &&, _Tp > > >::value, bool > = false>

constexpr std::experimental::fundamentals_v1::optional< _Tp >::optional | ( | _Up && | __t | ) |

inline explicit constexpr

Definition at line 536 of file optional.

## optional() [3/6]

template<typename _Tp >
template<typename _Up , enable_if_t< __and_< __not_< is_same< _Tp, _Up > >, is_constructible< _Tp, const _Up & >, is_convertible< const _Up &, _Tp >, __not_< __converts_from_optional< _Tp, _Up > > >::value, bool > = true>

constexpr std::experimental::fundamentals_v1::optional< _Tp >::optional | ( | const optional< _Up > & | __t | ) |

inline constexpr

Definition at line 546 of file optional.

## optional() [4/6]

template<typename _Tp >
template<typename _Up , enable_if_t< __and_< __not_< is_same< _Tp, _Up > >, is_constructible< _Tp, const _Up & >, __not_< is_convertible< const _Up &, _Tp > >, __not_< __converts_from_optional< _Tp, _Up > > >::value, bool > = false>

constexpr std::experimental::fundamentals_v1::optional< _Tp >::optional | ( | const optional< _Up > & | __t | ) |

inline explicit constexpr

Definition at line 559 of file optional.

## optional() [5/6]

template<typename _Tp >
template<typename _Up , enable_if_t< __and_< __not_< is_same< _Tp, _Up > >, is_constructible< _Tp, _Up && >, is_convertible< _Up &&, _Tp >, __not_< __converts_from_optional< _Tp, _Up > > >::value, bool > = true>

constexpr std::experimental::fundamentals_v1::optional< _Tp >::optional | ( | optional< _Up > && | __t | ) |

inline constexpr

Definition at line 572 of file optional.

## optional() [6/6]

template<typename _Tp >
template<typename _Up , enable_if_t< __and_< __not_< is_same< _Tp, _Up > >, is_constructible< _Tp, _Up && >, __not_< is_convertible< _Up &&, _Tp > >, __not_< __converts_from_optional< _Tp, _Up > > >::value, bool > = false>

constexpr std::experimental::fundamentals_v1::optional< _Tp >::optional | ( | optional< _Up > && | __t | ) |

inline explicit constexpr

Definition at line 585 of file optional.

## Member Function Documentation

## emplace() [1/2]

template<typename _Tp >
template<typename... _Args>

enable_if_t< is_constructible< _Tp, _Args &&... >::value > std::experimental::fundamentals_v1::optional< _Tp >::emplace | ( | _Args &&... | __args | ) |

inline

Definition at line 670 of file optional.

## emplace() [2/2]

template<typename _Tp >
template<typename _Up , typename... _Args>

enable_if_t< is_constructible< _Tp, initializer_list< _Up > &, _Args &&... >::value > std::experimental::fundamentals_v1::optional< _Tp >::emplace | ( | initializer_list< _Up > | __il,
|  | _Args &&... | __args
| ) |  |

inline

Definition at line 679 of file optional.

## operator bool()

template<typename _Tp >

constexpr std::experimental::fundamentals_v1::optional< _Tp >::operator bool | ( |  | ) | const

inline explicit constexpr noexcept

Definition at line 740 of file optional.

## operator*() [1/4]

template<typename _Tp >

constexpr _Tp & std::experimental::fundamentals_v1::optional< _Tp >::operator* | ( |  | ) | &

inline constexpr

Definition at line 729 of file optional.

## operator*() [2/4]

template<typename _Tp >

constexpr _Tp && std::experimental::fundamentals_v1::optional< _Tp >::operator* | ( |  | ) | &&

inline constexpr

Definition at line 733 of file optional.

## operator*() [3/4]

template<typename _Tp >

constexpr const _Tp & std::experimental::fundamentals_v1::optional< _Tp >::operator* | ( |  | ) | const &

inline constexpr

Definition at line 725 of file optional.

## operator*() [4/4]

template<typename _Tp >

constexpr const _Tp && std::experimental::fundamentals_v1::optional< _Tp >::operator* | ( |  | ) | const &&

inline constexpr

Definition at line 737 of file optional.

## operator->() [1/2]

template<typename _Tp >

_Tp * std::experimental::fundamentals_v1::optional< _Tp >::operator-> | ( |  | ) |

inline

Definition at line 721 of file optional.

## operator->() [2/2]

template<typename _Tp >

constexpr const _Tp * std::experimental::fundamentals_v1::optional< _Tp >::operator-> | ( |  | ) | const

inline constexpr

Definition at line 711 of file optional.

## operator=() [1/4]

template<typename _Tp >
template<typename _Up = _Tp>

enable_if_t< __and_< __not_< is_same< optional< _Tp >, decay_t< _Up > > >, is_constructible< _Tp, _Up >, __not_< __and_< is_scalar< _Tp >, is_same< _Tp, decay_t< _Up > > > >, is_assignable< _Tp &, _Up > >::value, optional & > std::experimental::fundamentals_v1::optional< _Tp >::operator= | ( | _Up && | __u | ) |

inline

Definition at line 607 of file optional.

## operator=() [2/4]

template<typename _Tp >
template<typename _Up >

enable_if_t< __and_< __not_< is_same< _Tp, _Up > >, is_constructible< _Tp, const _Up & >, is_assignable< _Tp &, _Up >, __not_< __converts_from_optional< _Tp, _Up > >, __not_< __assigns_from_optional< _Tp, _Up > > >::value, optional & > std::experimental::fundamentals_v1::optional< _Tp >::operator= | ( | const optional< _Up > & | __u | ) |

inline

Definition at line 626 of file optional.

## operator=() [3/4]

template<typename _Tp >

optional & std::experimental::fundamentals_v1::optional< _Tp >::operator= | ( | nullopt_t |  | ) |

inline noexcept

Definition at line 593 of file optional.

## operator=() [4/4]

template<typename _Tp >
template<typename _Up >

enable_if_t< __and_< __not_< is_same< _Tp, _Up > >, is_constructible< _Tp, _Up >, is_assignable< _Tp &, _Up >, __not_< __converts_from_optional< _Tp, _Up > >, __not_< __assigns_from_optional< _Tp, _Up > > >::value, optional & > std::experimental::fundamentals_v1::optional< _Tp >::operator= | ( | optional< _Up > && | __u | ) |

inline

Definition at line 651 of file optional.

## swap()

template<typename _Tp >

void std::experimental::fundamentals_v1::optional< _Tp >::swap | ( | optional< _Tp > & | __other | ) |

inline noexcept

Definition at line 689 of file optional.

## value() [1/4]

template<typename _Tp >

constexpr _Tp & std::experimental::fundamentals_v1::optional< _Tp >::value | ( |  | ) | &

inline constexpr

Definition at line 754 of file optional.

## value() [2/4]

template<typename _Tp >

constexpr _Tp && std::experimental::fundamentals_v1::optional< _Tp >::value | ( |  | ) | &&

inline constexpr

Definition at line 764 of file optional.

## value() [3/4]

template<typename _Tp >

constexpr const _Tp & std::experimental::fundamentals_v1::optional< _Tp >::value | ( |  | ) | const &

inline constexpr

Definition at line 744 of file optional.

## value() [4/4]

template<typename _Tp >

constexpr const _Tp && std::experimental::fundamentals_v1::optional< _Tp >::value | ( |  | ) | const &&

inline constexpr

Definition at line 774 of file optional.

## value_or() [1/2]

template<typename _Tp >
template<typename _Up >

_Tp std::experimental::fundamentals_v1::optional< _Tp >::value_or | ( | _Up && | __u | ) | &&

inline

Definition at line 798 of file optional.

## value_or() [2/2]

template<typename _Tp >
template<typename _Up >

constexpr _Tp std::experimental::fundamentals_v1::optional< _Tp >::value_or | ( | _Up && | __u | ) | const &

inline constexpr

Definition at line 785 of file optional.

The documentation for this class was generated from the following file:

- optional